// Stores undo for a variable or function change.

using System;
using System.Collections.Generic;



class Undo
{
	// store the current value of a symbol
	public Undo(Globals globals, string name)
	{
		mName = name;

		globals.TryGetValue(name, out mFunction);
	}



	// remember what changed, and what the previous value was
	string mName;

	Function mFunction;	



	// carry out an undo or redo operation
	public static void Perform(Stack<Undo> undo, Stack<Undo> redo, Globals globals)
	{	
		if (undo.Count <= 0)
			return;

		Undo pop = undo.Pop();

		redo.Push(new Undo(globals, pop.mName));

		globals[pop.mName] = pop.mFunction;

		if (pop.mFunction == null)
			Console.WriteLine("{0}=", pop.mName);
		else
			Console.WriteLine(pop.mFunction.SourceCode);
	}
}
