// Somewhat pointless wrapper to let me do a foreach loop over multiple
// lines of input text. Very Pythonic!

using System.Collections.Generic;
using System.IO;



class LineEnumerator
{
	// wrap ourselves around an input stream
	public LineEnumerator(TextReader input)
	{
		mInput = input;
	}



	// iteration function
	public IEnumerator<string> GetEnumerator()
	{
		string line;

		while ((line = mInput.ReadLine()) != null)
			yield return line;
	}



	// the underlying stream
	TextReader mInput;
}

